using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Inventarios._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Inventarios._1_Datos
{
    public class INV_InventarioLineas_Detalle_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            return null;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private INV_InventarioLineas_Detalle g_mdl_INV_InventarioLineas_Detalle = null;

        public INV_InventarioLineas_Detalle Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(INV_InventarioLineas_Detalle) + "." + nameof(INV_InventarioLineas_Detalle.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_INV_InventarioLineas_Detalle;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                           object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_INV_InventarioLineas_Detalle = obj_Exferia_Entities.Database.SqlQuery<INV_InventarioLineas_Detalle>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<INV_InventarioLineas_Detalle> g_lst_INV_InventarioLineas_Detalle = null;

        public List<INV_InventarioLineas_Detalle> Obtener_ModeloListado_Por_IdInventarioLinea(long _lng_idInventarioLinea)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(INV_InventarioLineas_Detalle) + "." + nameof(INV_InventarioLineas_Detalle.idInventarioLinea) + "=@idInventarioLinea ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInventarioLinea",  _lng_idInventarioLinea)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdInventarioLinea), true);
            }

            return g_lst_INV_InventarioLineas_Detalle;
        }

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_INV_InventarioLineas_Detalle = obj_Exferia_Entities.Database.SqlQuery<INV_InventarioLineas_Detalle>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(INV_InventarioLineas_Detalle.id) + "," +
                    nameof(INV_InventarioLineas_Detalle.idInventarioLinea) + "," +
                    nameof(INV_InventarioLineas_Detalle.idNomenclaturaPrecio) + "," +
                    nameof(INV_InventarioLineas_Detalle.precio) + "," +
                    nameof(INV_InventarioLineas_Detalle.importe) + "," +
                    nameof(INV_InventarioLineas_Detalle.fechaBorrado) +
                " FROM " + nameof(INV_InventarioLineas_Detalle);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                INV_InventarioLineas_Detalle mdl_INV_InventariosLineas_Detalles_AGrabar = (INV_InventarioLineas_Detalle)_mdl_obj;
                INV_InventarioLineas_Detalle mdl_INV_InventariosLineas_Detalles_DatosViejos = new INV_InventarioLineas_Detalle();

                // Ver si existe ######################################################################
                INV_InventarioLineas_Detalle mdl_INV_InventariosLineas_Detalles_Final = Obtener_Modelo_Por_Id(mdl_INV_InventariosLineas_Detalles_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_INV_InventariosLineas_Detalles_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_INV_InventariosLineas_Detalles_Final, mdl_INV_InventariosLineas_Detalles_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_INV_InventariosLineas_Detalles_AGrabar, mdl_INV_InventariosLineas_Detalles_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(INV_InventarioLineas_Detalle) +
                                           " SET " +
                                                nameof(INV_InventarioLineas_Detalle.idInventarioLinea) + "=@idInventarioLinea," +
                                                nameof(INV_InventarioLineas_Detalle.idNomenclaturaPrecio) + "=@idNomenclaturaPrecio," +
                                                nameof(INV_InventarioLineas_Detalle.precio) + "=@precio," +
                                                nameof(INV_InventarioLineas_Detalle.importe) + "=@importe," +
                                                nameof(INV_InventarioLineas_Detalle.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(INV_InventarioLineas_Detalle.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idInventarioLinea",  mdl_INV_InventariosLineas_Detalles_Final.idInventarioLinea),
                         new SqlParameter("@idNomenclaturaPrecio",  mdl_INV_InventariosLineas_Detalles_Final.idNomenclaturaPrecio),
                         new SqlParameter("@precio",  mdl_INV_InventariosLineas_Detalles_Final.precio),
                         mdl_INV_InventariosLineas_Detalles_Final.importe != null
                            ?   new SqlParameter("@importe", mdl_INV_InventariosLineas_Detalles_Final.importe.Value)
                            :   new SqlParameter("@importe",  DBNull.Value),
                         mdl_INV_InventariosLineas_Detalles_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_INV_InventariosLineas_Detalles_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         new SqlParameter("@id",  mdl_INV_InventariosLineas_Detalles_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_INV_InventariosLineas_Detalles_Final.id;
                }
                //INSERT
                else
                {
                    mdl_INV_InventariosLineas_Detalles_Final = new INV_InventarioLineas_Detalle();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_INV_InventariosLineas_Detalles_AGrabar, mdl_INV_InventariosLineas_Detalles_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(INV_InventarioLineas_Detalle) +
                                              " (" +
                                                      nameof(INV_InventarioLineas_Detalle.idInventarioLinea) + "," +
                                                      nameof(INV_InventarioLineas_Detalle.idNomenclaturaPrecio) + "," +
                                                      nameof(INV_InventarioLineas_Detalle.precio) + "," +
                                                      nameof(INV_InventarioLineas_Detalle.importe) + "," +
                                                      nameof(INV_InventarioLineas_Detalle.fechaBorrado) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(INV_InventarioLineas_Detalle.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@idInventarioLinea," +
                                                  "@idNomenclaturaPrecio," +
                                                  "@precio," +
                                                  "@importe," +
                                                  "@fechaBorrado" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idInventarioLinea",  mdl_INV_InventariosLineas_Detalles_Final.idInventarioLinea),
                         new SqlParameter("@idNomenclaturaPrecio",  mdl_INV_InventariosLineas_Detalles_Final.idNomenclaturaPrecio),
                         new SqlParameter("@precio",  mdl_INV_InventariosLineas_Detalles_Final.precio),
                         mdl_INV_InventariosLineas_Detalles_Final.importe != null
                            ?   new SqlParameter("@importe", mdl_INV_InventariosLineas_Detalles_Final.importe.Value)
                            :   new SqlParameter("@importe",  DBNull.Value),
                         mdl_INV_InventariosLineas_Detalles_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_INV_InventariosLineas_Detalles_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(INV_InventarioLineas_Detalle), mdl_INV_InventariosLineas_Detalles_DatosViejos, mdl_INV_InventariosLineas_Detalles_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Insertar(INV_InventarioLineas_Detalle _mdl_INV_InventarioLineas_Detalle)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

               
                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(INV_InventarioLineas_Detalle) +
                                            " (" +
                                                    nameof(INV_InventarioLineas_Detalle.idInventarioLinea) + "," +
                                                    nameof(INV_InventarioLineas_Detalle.idNomenclaturaPrecio) + "," +
                                                    nameof(INV_InventarioLineas_Detalle.precio) + "," +
                                                    nameof(INV_InventarioLineas_Detalle.importe) + "," +
                                                    nameof(INV_InventarioLineas_Detalle.fechaBorrado) +
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(INV_InventarioLineas_Detalle.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idInventarioLinea," +
                                                "@idNomenclaturaPrecio," +
                                                "@precio," +
                                                "@importe," +
                                                "@fechaBorrado" +
                                            " ) ";

                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@idInventarioLinea",  _mdl_INV_InventarioLineas_Detalle.idInventarioLinea),
                        new SqlParameter("@idNomenclaturaPrecio",  _mdl_INV_InventarioLineas_Detalle.idNomenclaturaPrecio),
                        new SqlParameter("@precio",  _mdl_INV_InventarioLineas_Detalle.precio),
                        _mdl_INV_InventarioLineas_Detalle.importe != null
                        ?   new SqlParameter("@importe", _mdl_INV_InventarioLineas_Detalle.importe.Value)
                        :   new SqlParameter("@importe",  DBNull.Value),
                        _mdl_INV_InventarioLineas_Detalle.fechaBorrado != null
                        ?   new SqlParameter("@fechaBorrado", _mdl_INV_InventarioLineas_Detalle.fechaBorrado.Value)
                        :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                };
                #endregion
                    
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insert, arr_Parametros_Insert);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }

        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                INV_InventarioLineas_Detalle mdl_INV_InventariosLineas_Detalles_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_INV_InventariosLineas_Detalles_Final != null)
                {
                    //Se intenta borrar, si diera un error porque esta relacionado se graba la fecha de baja
                    try
                    {

                        #region Delete
                        string str_SQL_Delete = " DELETE FROM  " + nameof(INV_InventarioLineas_Detalle) +
                                                " WHERE " +
                                                    nameof(INV_InventarioLineas_Detalle.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Delete = new object[]
                        {
                                new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Delete
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                        //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(INV_InventarioLineas_Detalle), null, mdl_INV_InventariosLineas_Detalles_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                    }
                    catch (Exception ex)
                    {
                        var sqlException = ex.GetBaseException() as SqlException;
                        if (sqlException != null)
                        {
                            if (sqlException.Errors.Count > 0)
                            {
                                switch (sqlException.Errors[0].Number)
                                {
                                    case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                        bol_ActualizarFechaBorrado = true;
                                        break;
                                    default:
                                        throw;
                                }
                            }
                        }
                        else
                        {
                            throw;
                        }
                    }
                }

                //Actualizar la fecha de baja, al no poder borrarlo por tener relaciones
                if (bol_ActualizarFechaBorrado)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(INV_InventarioLineas_Detalle) +
                                                " SET " +
                                                nameof(INV_InventarioLineas_Detalle.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(INV_InventarioLineas_Detalle.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(INV_InventarioLineas_Detalle), null, mdl_INV_InventariosLineas_Detalles_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idInventarioLinea = (List<long>)_mdl_obj;

                if (lst_idInventarioLinea != null & lst_idInventarioLinea.Count > 0)
                {
                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idInventarioLinea);

                    string str_SQL = " DELETE FROM " + nameof(INV_InventarioLineas_Detalle) +
                                     " WHERE " + nameof(INV_InventarioLineas_Detalle.idInventarioLinea) + " in (" + str_Filtros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(INV_InventarioLineas_Detalle_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
